/**

JSZip - A Javascript class for generating and reading zip files
<http://stuartk.com/jszip>

(c) 2009-2012 Stuart Knightley <stuart [at] stuartk.com>
Dual licenced under the MIT license or GPLv3. See LICENSE.markdown.

Usage:
   zip = new JSZip();
   zip.file("hello.txt", "Hello, World!").add("tempfile", "nothing");
   zip.folder("images").file("smile.gif", base64Data, {base64: true});
   zip.file("Xmas.txt", "Ho ho ho !", {date : new Date("December 25, 2007 00:00:01")});
   zip.remove("tempfile");

   base64zip = zip.generate();

**/var JSZip=function(a,b){this.files={},this.root="",a&&this.load(a,b)};JSZip.signature={LOCAL_FILE_HEADER:"PK\x03\x04",CENTRAL_FILE_HEADER:"PK\x01\x02",CENTRAL_DIRECTORY_END:"PK\x05\x06",ZIP64_CENTRAL_DIRECTORY_LOCATOR:"PK\x06\x07",ZIP64_CENTRAL_DIRECTORY_END:"PK\x06\x06",DATA_DESCRIPTOR:"PK\x07\b"},JSZip.defaults={base64:!1,binary:!1,dir:!1,date:null},JSZip.prototype=function(){var a=String.fromCharCode,b=function(a,b,c){this.name=a,this.data=b,this.options=c};b.prototype={asText:function(){var a=this.data;return null===a||"undefined"==typeof a?"":(this.options.base64&&(a=JSZipBase64.decode(a)),this.options.binary&&(a=JSZip.prototype.utf8decode(a)),a)},asBinary:function(){var a=this.data;return null===a||"undefined"==typeof a?"":(this.options.base64&&(a=JSZipBase64.decode(a)),this.options.binary||(a=JSZip.prototype.utf8encode(a)),a)},asUint8Array:function(){return JSZip.utils.string2Uint8Array(this.asBinary())},asArrayBuffer:function(){return JSZip.utils.string2Uint8Array(this.asBinary()).buffer}};var c=function(b,c){var d,e="";for(d=0;d<c;d++)e+=a(255&b),b>>>=8;return e},d=function(){var a,b,c={};for(a=0;a<arguments.length;a++)for(b in arguments[a])arguments[a].hasOwnProperty(b)&&"undefined"==typeof c[b]&&(c[b]=arguments[a][b]);return c},e=function(a){return a=a||{},!0===a.base64&&null==a.binary&&(a.binary=!0),a=d(a,JSZip.defaults),a.date=a.date||new Date,a},f=function(a,c,d){var f=g(a);if(f&&h.call(this,f),d=e(d),d.dir||null===c||"undefined"==typeof c)d.base64=!1,d.binary=!1,c=null;else if(JSZip.support.uint8array&&c instanceof Uint8Array)d.base64=!1,d.binary=!0,c=JSZip.utils.uint8Array2String(c);else if(JSZip.support.arraybuffer&&c instanceof ArrayBuffer){d.base64=!1,d.binary=!0;var i=new Uint8Array(c);c=JSZip.utils.uint8Array2String(i)}else d.binary&&!d.base64&&(!0!==d.optimizedBinaryString&&(c=JSZip.utils.string2binary(c)),delete d.optimizedBinaryString);return this.files[a]=new b(a,c,d)},g=function(a){"/"==a.slice(-1)&&(a=a.substring(0,a.length-1));var b=a.lastIndexOf("/");return 0<b?a.substring(0,b):""},h=function(a){if("/"!=a.slice(-1)&&(a+="/"),!this.files[a]){var b=g(a);b&&h.call(this,b),f.call(this,a,null,{dir:!0})}return this.files[a]},i=function(a,b,d){var e,f,g=b!==a.name,h=a.asBinary(),i=a.options;e=i.date.getHours(),e<<=6,e|=i.date.getMinutes(),e<<=5,e|=i.date.getSeconds()/2,f=i.date.getFullYear()-1980,f<<=4,f|=i.date.getMonth()+1,f<<=5,f|=i.date.getDate();var j=null!==h&&0!==h.length,k=JSZip.compressions[d],l=j?k.compress(h):"",m="";return m+="\n\0",m+=g?"\0\b":"\0\0",m+=j?k.magic:JSZip.compressions.STORE.magic,m+=c(e,2),m+=c(f,2),m+=j?c(this.crc32(h),4):"\0\0\0\0",m+=j?c(l.length,4):"\0\0\0\0",m+=j?c(h.length,4):"\0\0\0\0",m+=c(b.length,2),m+="\0\0",{header:m,compressedData:l}};return{load:function(){throw new Error("Load method is not defined. Is the file jszip-load.js included ?")},filter:function(a){var c,e,f,g,h=[];for(c in this.files)this.files.hasOwnProperty(c)&&(f=this.files[c],g=new b(f.name,f.data,d(f.options)),e=c.slice(this.root.length,c.length),c.slice(0,this.root.length)===this.root&&a(e,g)&&h.push(g));return h},file:function(a,b,c){if(1===arguments.length){if(a instanceof RegExp){var d=a;return this.filter(function(a,b){return!b.options.dir&&d.test(a)})}return this.filter(function(b,c){return!c.options.dir&&b===a})[0]||null}return a=this.root+a,f.call(this,a,b,c),this},folder:function(a){if(!a)return this;if(a instanceof RegExp)return this.filter(function(b,c){return c.options.dir&&a.test(b)});var b=this.root+a,c=h.call(this,b),d=this.clone();return d.root=c.name,d},remove:function(a){a=this.root+a;var b=this.files[a];if(b||("/"!=a.slice(-1)&&(a+="/"),b=this.files[a]),b)if(!b.options.dir)delete this.files[a];else for(var c=this.filter(function(b,c){return c.name.slice(0,a.length)===a}),d=0;d<c.length;d++)delete this.files[c[d].name];return this},generate:function(a){a=d(a||{},{base64:!0,compression:"STORE",type:"base64"});var b=a.compression.toUpperCase(),e=[],f=[],g=0;if(!JSZip.compressions[b])throw b+" is not a valid compression method !";for(var h in this.files)if(this.files.hasOwnProperty(h)){var j=this.files[h],k=this.utf8encode(j.name),l="",m="",n=i.call(this,j,k,b);l=JSZip.signature.LOCAL_FILE_HEADER+n.header+k+n.compressedData,m=JSZip.signature.CENTRAL_FILE_HEADER+"\x14\0"+n.header+"\0\0\0\0\0\0"+(!0===this.files[h].options.dir?"\x10\0\0\0":"\0\0\0\0")+c(g,4)+k,g+=l.length,f.push(l),e.push(m)}var o=f.join(""),p=e.join(""),q="";q=JSZip.signature.CENTRAL_DIRECTORY_END+"\0\0\0\0"+c(f.length,2)+c(f.length,2)+c(p.length,4)+c(o.length,4)+"\0\0";var r=o+p+q;switch(a.type.toLowerCase()){case"uint8array":return JSZip.utils.string2Uint8Array(r);case"arraybuffer":return JSZip.utils.string2Uint8Array(r).buffer;case"blob":return JSZip.utils.string2Blob(r);case"base64":return a.base64?JSZipBase64.encode(r):r;default:return r;}},crc32:function(a,b){if(""===a||"undefined"==typeof a)return 0;var c=[0,1996959894,3993919788,2567524794,124634137,1886057615,3915621685,2657392035,249268274,2044508324,3772115230,2547177864,162941995,2125561021,3887607047,2428444049,498536548,1789927666,4089016648,2227061214,450548861,1843258603,4107580753,2211677639,325883990,1684777152,4251122042,2321926636,335633487,1661365465,4195302755,2366115317,997073096,1281953886,3579855332,2724688242,1006888145,1258607687,3524101629,2768942443,901097722,1119000684,3686517206,2898065728,853044451,1172266101,3705015759,2882616665,651767980,1373503546,3369554304,3218104598,565507253,1454621731,3485111705,3099436303,671266974,1594198024,3322730930,2970347812,795835527,1483230225,3244367275,3060149565,1994146192,31158534,2563907772,4023717930,1907459465,112637215,2680153253,3904427059,2013776290,251722036,2517215374,3775830040,2137656763,141376813,2439277719,3865271297,1802195444,476864866,2238001368,4066508878,1812370925,453092731,2181625025,4111451223,1706088902,314042704,2344532202,4240017532,1658658271,366619977,2362670323,4224994405,1303535960,984961486,2747007092,3569037538,1256170817,1037604311,2765210733,3554079995,1131014506,879679996,2909243462,3663771856,1141124467,855842277,2852801631,3708648649,1342533948,654459306,3188396048,3373015174,1466479909,544179635,3110523913,3462522015,1591671054,702138776,2966460450,3352799412,1504918807,783551873,3082640443,3233442989,3988292384,2596254646,62317068,1957810842,3939845945,2647816111,81470997,1943803523,3814918930,2489596804,225274430,2053790376,3826175755,2466906013,167816743,2097651377,4027552580,2265490386,503444072,1762050814,4150417245,2154129355,426522225,1852507879,4275313526,2312317920,282753626,1742555852,4189708143,2394877945,397917763,1622183637,3604390888,2714866558,953729732,1340076626,3518719985,2797360999,1068828381,1219638859,3624741850,2936675148,906185462,1090812512,3747672003,2825379669,829329135,1181335161,3412177804,3160834842,628085408,1382605366,3423369109,3138078467,570562233,1426400815,3317316542,2998733608,733239954,1555261956,3268935591,3050360625,752459403,1541320221,2607071920,3965973030,1969922972,40735498,2617837225,3943577151,1913087877,83908371,2512341634,3803740692,2075208622,213261112,2463272603,3855990285,2094854071,198958881,2262029012,4057260610,1759359992,534414190,2176718541,4139329115,1873836001,414664567,2282248934,4279200368,1711684554,285281116,2405801727,4167216745,1634467795,376229701,2685067896,3608007406,1308918612,956543938,2808555105,3495958263,1231636301,1047427035,2932959818,3654703836,1088359270,936918000,2847714899,3736837829,1202900863,817233897,3183342108,3401237130,1404277552,615818150,3134207493,3453421203,1423857449,601450431,3009837614,3294710456,1567103746,711928724,3020668471,3272380065,1510334235,755167117];"undefined"==typeof b&&(b=0);var d=0,e=0;b^=-1;for(var f=0,g=a.length;f<g;f++)e=255&(b^a.charCodeAt(f)),d=c[e],b=b>>>8^d;return-1^b},clone:function(){var a=new JSZip;for(var b in this)"function"!=typeof this[b]&&(a[b]=this[b]);return a},utf8encode:function(b){b=b.replace(/\r\n/g,"\n");for(var d,c="",e=0;e<b.length;e++)d=b.charCodeAt(e),128>d?c+=a(d):127<d&&2048>d?(c+=a(192|d>>6),c+=a(128|63&d)):(c+=a(224|d>>12),c+=a(128|63&d>>6),c+=a(128|63&d));return c},utf8decode:function(b){for(var d="",e=0,f=0,c=0,g=0;e<b.length;)f=b.charCodeAt(e),128>f?(d+=a(f),e++):191<f&&224>f?(c=b.charCodeAt(e+1),d+=a((31&f)<<6|63&c),e+=2):(c=b.charCodeAt(e+1),g=b.charCodeAt(e+2),d+=a((15&f)<<12|(63&c)<<6|63&g),e+=3);return d}}}(),JSZip.compressions={STORE:{magic:"\0\0",compress:function(a){return a},uncompress:function(a){return a}}},JSZip.support={arraybuffer:function(){return"undefined"!=typeof ArrayBuffer&&"undefined"!=typeof Uint8Array}(),uint8array:function(){return"undefined"!=typeof Uint8Array}(),blob:function(){if("undefined"==typeof ArrayBuffer)return!1;var a=new ArrayBuffer(0);try{return 0===new Blob([a],{type:"application/zip"}).size}catch(a){}try{var b=new(window.BlobBuilder||window.WebKitBlobBuilder||window.MozBlobBuilder||window.MSBlobBuilder);return b.append(a),0===b.getBlob("application/zip").size}catch(a){}return!1}()},JSZip.utils={string2binary:function(a){for(var b="",c=0;c<a.length;c++)b+=String.fromCharCode(255&a.charCodeAt(c));return b},string2Uint8Array:function(a){if(!JSZip.support.uint8array)throw new Error("Uint8Array is not supported by this browser");for(var b=new ArrayBuffer(a.length),c=new Uint8Array(b),d=0;d<a.length;d++)c[d]=a.charCodeAt(d);return c},uint8Array2String:function(a){if(!JSZip.support.uint8array)throw new Error("Uint8Array is not supported by this browser");for(var b="",c=0;c<a.length;c++)b+=String.fromCharCode(a[c]);return b},string2Blob:function(a){if(!JSZip.support.blob)throw new Error("Blob is not supported by this browser");var b=JSZip.utils.string2Uint8Array(a).buffer;try{return new Blob([b],{type:"application/zip"})}catch(a){}try{var c=new(window.BlobBuilder||window.WebKitBlobBuilder||window.MozBlobBuilder||window.MSBlobBuilder);return c.append(b),c.getBlob("application/zip")}catch(a){}throw new Error("Bug : can't construct the Blob.")}};var JSZipBase64=function(){var a=String.fromCharCode,b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";return{encode:function(a){for(var c,d,e,f,g,h,j,k="",l=0;l<a.length;)c=a.charCodeAt(l++),d=a.charCodeAt(l++),e=a.charCodeAt(l++),f=c>>2,g=(3&c)<<4|d>>4,h=(15&d)<<2|e>>6,j=63&e,isNaN(d)?h=j=64:isNaN(e)&&(j=64),k=k+b.charAt(f)+b.charAt(g)+b.charAt(h)+b.charAt(j);return k},decode:function(c){var d,e,f,g,h,j,k,l="",m=0;for(c=c.replace(/[^A-Za-z0-9\+\/\=]/g,"");m<c.length;)g=b.indexOf(c.charAt(m++)),h=b.indexOf(c.charAt(m++)),j=b.indexOf(c.charAt(m++)),k=b.indexOf(c.charAt(m++)),d=g<<2|h>>4,e=(15&h)<<4|j>>2,f=(3&j)<<6|k,l+=a(d),64!=j&&(l+=a(e)),64!=k&&(l+=a(f));return l}}}();